import type { TagsBase } from '../../../storage/BaseRecord';
import type { ActionMenuRole } from '../ActionMenuRole';
import type { ActionMenuState } from '../ActionMenuState';
import { BaseRecord } from '../../../storage/BaseRecord';
import { ActionMenuSelection, ActionMenu } from '../models';
export interface ActionMenuRecordProps {
    id?: string;
    state: ActionMenuState;
    role: ActionMenuRole;
    createdAt?: Date;
    connectionId: string;
    threadId: string;
    menu?: ActionMenu;
    performedAction?: ActionMenuSelection;
    tags?: CustomActionMenuTags;
}
export declare type CustomActionMenuTags = TagsBase;
export declare type DefaultActionMenuTags = {
    role: ActionMenuRole;
    connectionId: string;
    threadId: string;
};
export declare class ActionMenuRecord extends BaseRecord<DefaultActionMenuTags, CustomActionMenuTags> implements ActionMenuRecordProps {
    state: ActionMenuState;
    role: ActionMenuRole;
    connectionId: string;
    threadId: string;
    menu?: ActionMenu;
    performedAction?: ActionMenuSelection;
    static readonly type = "ActionMenuRecord";
    readonly type = "ActionMenuRecord";
    constructor(props: ActionMenuRecordProps);
    getTags(): {
        role: ActionMenuRole;
        connectionId: string;
        threadId: string;
    };
    assertState(expectedStates: ActionMenuState | ActionMenuState[]): void;
    assertRole(expectedRole: ActionMenuRole): void;
}
