import type { InboundMessageContext } from '../../../agent/models/InboundMessageContext';
import type { ActionMenuProblemReportMessage } from '../messages';
import type { ClearMenuOptions, CreateMenuOptions, CreatePerformOptions, CreateRequestOptions, FindMenuOptions } from './ActionMenuServiceOptions';
import { AgentConfig } from '../../../agent/AgentConfig';
import { EventEmitter } from '../../../agent/EventEmitter';
import { PerformMessage, MenuMessage, MenuRequestMessage } from '../messages';
import { ActionMenuRepository, ActionMenuRecord } from '../repository';
export declare class ActionMenuService {
    private actionMenuRepository;
    private eventEmitter;
    private logger;
    constructor(actionMenuRepository: ActionMenuRepository, agentConfig: AgentConfig, eventEmitter: EventEmitter);
    createRequest(options: CreateRequestOptions): Promise<{
        message: MenuRequestMessage;
        record: ActionMenuRecord;
    }>;
    processRequest(messageContext: InboundMessageContext<MenuRequestMessage>): Promise<ActionMenuRecord>;
    createMenu(options: CreateMenuOptions): Promise<{
        message: MenuMessage;
        record: ActionMenuRecord;
    }>;
    processMenu(messageContext: InboundMessageContext<MenuMessage>): Promise<void>;
    createPerform(options: CreatePerformOptions): Promise<{
        message: PerformMessage;
        record: ActionMenuRecord;
    }>;
    processPerform(messageContext: InboundMessageContext<PerformMessage>): Promise<void>;
    clearMenu(options: ClearMenuOptions): Promise<ActionMenuRecord>;
    processProblemReport(messageContext: InboundMessageContext<ActionMenuProblemReportMessage>): Promise<ActionMenuRecord>;
    findById(actionMenuRecordId: string): Promise<ActionMenuRecord | null>;
    find(options: FindMenuOptions): Promise<ActionMenuRecord | null>;
    private emitStateChangedEvent;
}
