import type { DependencyManager } from '../../plugins';
import type { BasicMessageTags } from './repository/BasicMessageRecord';
import { Dispatcher } from '../../agent/Dispatcher';
import { MessageSender } from '../../agent/MessageSender';
import { ConnectionService } from '../connections';
import { BasicMessageService } from './services';
export declare class BasicMessagesModule {
    private basicMessageService;
    private messageSender;
    private connectionService;
    constructor(dispatcher: Dispatcher, basicMessageService: BasicMessageService, messageSender: MessageSender, connectionService: ConnectionService);
    sendMessage(connectionId: string, message: string): Promise<void>;
    findAllByQuery(query: Partial<BasicMessageTags>): Promise<import("./repository").BasicMessageRecord[]>;
    private registerHandlers;
    /**
     * Registers the dependencies of the basic message module on the dependency manager.
     */
    static register(dependencyManager: DependencyManager): void;
}
