import type { AgentConfig } from '../../../../../agent/AgentConfig';
import type { Handler } from '../../../../../agent/Handler';
import type { InboundMessageContext } from '../../../../../agent/models/InboundMessageContext';
import type { DidCommMessageRepository } from '../../../../../storage';
import type { RoutingService } from '../../../../routing/services/RoutingService';
import type { V2CredentialService } from '../V2CredentialService';
import { V2OfferCredentialMessage } from '../messages/V2OfferCredentialMessage';
export declare class V2OfferCredentialHandler implements Handler {
    private credentialService;
    private agentConfig;
    private routingService;
    supportedMessages: (typeof V2OfferCredentialMessage)[];
    private didCommMessageRepository;
    constructor(credentialService: V2CredentialService, agentConfig: AgentConfig, routingService: RoutingService, didCommMessageRepository: DidCommMessageRepository);
    handle(messageContext: InboundMessageContext<V2OfferCredentialMessage>): Promise<import("../../../../../types").OutboundMessage<import("..").V2RequestCredentialMessage> | import("../../../../../types").OutboundServiceMessage<import("..").V2RequestCredentialMessage> | undefined>;
    private acceptOffer;
}
