import type { DependencyManager } from './DependencyManager';
export interface Module {
    new (...args: any[]): any;
    register(dependencyManager: DependencyManager): void;
}
/**
 * Decorator that marks the class as a module. Will enforce the required interface for a module (with static methods)
 * on the class declaration.
 */
export declare function module(): <U extends Module>(constructor: U) => U;
